<?php
/*---------------------------------------------------------------------*\
| Product Name	           |                                    |
| Translation Into Arabic  | Mohamed Zedan                              |
| My Web Sites         	   | WwW.NeWSoFt333.CoM & WwW.R0ShA.CoM 	|
| My Mobile Number         | No. 00971508336501 & 00971554745231        |
| My E-mail 	           | mcq@windowslive.com & admin@newsoft333.com |
\*---------------------------------------------------------------------*/ 

// ####################### SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);

// #################### DEFINE IMPORTANT CONSTANTS #######################
define('THIS_SCRIPT', 'item_ratings');
define('CSRF_PROTECTION', true);
define('LOCATION_BYPASS', 1);
define('NOPMPOPUP', 1);

// ################### PRE-CACHE TEMPLATES AND DATA ######################
// get special phrase groups
$phrasegroups = array();

// get special data templates from the datastore
$specialtemplates = array();

// pre-cache templates used by all actions
$globaltemplates = array(
	'vb4sidebar_template',
	'vb4sidebar_userdefined',
	'vb4sidebar_attachments',
	'vb4sidebar_slideshows',
	'vb4sidebar_albums',
	'vb4sidebar_blog',
	'vb4sidebar_threads',
	'vb4sidebar_posts',
	'vb4sidebar_socialgroups',
	'vb4sidebar_polls',
	'vb4sidebar_members',
	'vb4sidebar_tagcloud',
	'vb4sidebar_tagcloud_page',
	'vb4sidebar_javascript',
	'vb4sidebar_before_controls above postbits',
	'vb4sidebar_before_main',
	'vb4sidebar_after_main',
	'vb4sidebar_after_slidebar_div',
	'vb4sidebar_before_end_form'
);


// pre-cache templates used by specific actions
$actiontemplates = array();


// ######################### REQUIRE BACK-END ############################
require_once('./global.php');

// #######################################################################
// ######################## START MAIN SCRIPT ############################
// #######################################################################

$vbulletin->input->clean_array_gpc('r', array('securitytoken' => TYPE_STR));
$securitytoken = $vbulletin->GPC['securitytoken'];


if (($_REQUEST['do'] == 'attachments') OR ($_REQUEST['do'] == 'latestattachments') OR ($_REQUEST['do'] == 'mostviewedattachments')){

	require_once(DIR . '/includes/functions_search.php');
	require_once(DIR . '/includes/functions_misc.php');

	// #############################################################################
	// build search hash
	$query = '';
	$searchuser = $user['username'];
	$exactname = 1;
	$starteronly = 0;
	$forumchoice = $foruminfo['forumid'];
	$childforums = 1;
	$titleonly = 0;
	$showposts = 1;
	$searchdate = 0;
	$beforeafter = 'after';
	$replyless = 0;
	$replylimit = 0;
	$searchthreadid = 0;

	$searchhash = md5(TIMENOW . "||" . $vbulletin->userinfo['userid'] . "||" . strtolower($searchuser) . "||$exactname||$starteronly||$forumchoice||$childforums||$titleonly||$showposts||$searchdate||$beforeafter||$replyless||$replylimit||$searchthreadid");

	// start search timer
	$searchtime = microtime();

	$forumids = array();
	$noforumids = array();
	// #############################################################################
	// check to see if we should be searching in a particular forum or forums
	if ($forumids = fetch_search_forumids($vbulletin->GPC['forumchoice'], $vbulletin->GPC['childforums']))
	{
		$showforums = true;
	}
	else
	{
		foreach ($vbulletin->forumcache AS $forumid => $forum)
		{
			$fperms =& $vbulletin->userinfo['forumpermissions']["$forumid"];
			if (($fperms & $vbulletin->bf_ugp_forumpermissions['canview']))
			{
				$forumids[] = $forumid;
			}
		}
		$showforums = false;
	}

	if (empty($forumids))
	{
		eval(standard_error(fetch_error('searchnoresults', $displayCommon), '', false));
	}
	else
	{
		// query post ids in $orberby DESC order...
		$orderedids = array();
		switch ($_REQUEST['do']){
			case 'counter': 
				$posts = $db->query_read("
					SELECT *
					FROM " . TABLE_PREFIX . "post AS post
					INNER JOIN " . TABLE_PREFIX . "attachment AS attachment ON(attachment.postid = post.postid)
					WHERE post.attach > 0
					ORDER BY attachment.counter DESC
					LIMIT " . ($vbulletin->options['maxresults'] * 2) . "
				");
				break;
			default: 
				$posts = $db->query_read("
					SELECT *
					FROM " . TABLE_PREFIX . "post AS post
					INNER JOIN " . TABLE_PREFIX . "attachment AS attachment ON(attachment.postid = post.postid)
					WHERE post.attach > 0
					ORDER BY attachment.dateline DESC
					LIMIT " . ($vbulletin->options['maxresults'] * 2) . "
				");
				break;
		}

		while ($post = $db->fetch_array($posts))
		{
			$orderedids[] = $post['postid'];
		}
		unset($post);
		$db->free_result($posts);

		// did we get some results?
		if (empty($orderedids))
		{
			eval(standard_error(fetch_error('searchnoresults', $displayCommon), '', false));
		}

		// set display terms
		$display = array(
			'words' => array(),
			'highlight' => array(),
			'common' => array(),
			'users' => array($user['userid'] => $user['username']),
			'forums' => iif($showforums, $display['forums'], 0),
			'options' => array(
				'starteronly' => 0,
				'childforums' => 1,
				'action' => 'process'
			)
		);

		// end search timer
		$searchtime = number_format(fetch_microtime_difference($searchtime), 5, '.', '');

		/*insert query*/
		$db->query_write("
			REPLACE INTO " . TABLE_PREFIX . "search (userid, ipaddress, personal, searchuser, forumchoice, sortby, sortorder, searchtime, showposts, orderedids, dateline, displayterms, searchhash)
			VALUES (" . $vbulletin->userinfo['userid'] . ", '" . $db->escape_string(IPADDRESS) . "', 1, '" . $db->escape_string($user['username']) . "', '" . $db->escape_string($forumchoice) . "', 'post.dateline', 'DESC', $searchtime, 1, '" . $db->escape_string(implode(',', $orderedids)) . "', " . TIMENOW . ", '" . $db->escape_string(serialize($display)) . "', '" . $db->escape_string($searchhash) . "')
		");
		$searchid = $db->insert_id();

		$vbulletin->url = 'search.php?' . $vbulletin->session->vars['sessionurl'] . "searchid=$searchid";
		eval(print_standard_redirect('search'));
	}
}


if (($_REQUEST['do'] == 'latestposts') OR ($_REQUEST['do'] == 'mostthankedposts') OR ($_REQUEST['do'] == 'latestpolls') OR ($_REQUEST['do'] == 'mostviewedpolls') OR ($_REQUEST['do'] == 'hottestpolls') OR ($_REQUEST['do'] == 'latestthreads') OR ($_REQUEST['do'] == 'mostviewedthreads') OR ($_REQUEST['do'] == 'hottestthreads')){

	require_once(DIR . '/includes/functions_search.php');
	require_once(DIR . '/includes/functions_misc.php');

	$orberby = $vbulletin->input->clean_gpc('r', 'orderby', TYPE_UINT);

	// #############################################################################
	// build search hash
	$query = '';
	$searchuser = $user['username'];
	$exactname = 1;
	$starteronly = 0;
	$forumchoice = $foruminfo['forumid'];
	$childforums = 1;
	$titleonly = 0;
	$showposts = 1;
	$searchdate = 0;
	$beforeafter = 'after';
	$replyless = 0;
	$replylimit = 0;
	$searchthreadid = 0;

	$searchhash = md5(TIMENOW . "||" . $vbulletin->userinfo['userid'] . "||" . strtolower($searchuser) . "||$exactname||$starteronly||$forumchoice||$childforums||$titleonly||$showposts||$searchdate||$beforeafter||$replyless||$replylimit||$searchthreadid");

	// start search timer
	$searchtime = microtime();

	$forumids = array();
	$noforumids = array();
	// #############################################################################
	// check to see if we should be searching in a particular forum or forums
	if ($forumids = fetch_search_forumids($vbulletin->GPC['forumchoice'], $vbulletin->GPC['childforums']))
	{
		$showforums = true;
	}
	else
	{
		foreach ($vbulletin->forumcache AS $forumid => $forum)
		{
			$fperms =& $vbulletin->userinfo['forumpermissions']["$forumid"];
			if (($fperms & $vbulletin->bf_ugp_forumpermissions['canview']))
			{
				$forumids[] = $forumid;
			}
		}
		$showforums = false;
	}

	if (empty($forumids))
	{
		eval(standard_error(fetch_error('searchnoresults', $displayCommon), '', false));
	}
	else
	{
		// query post ids in $orberby DESC order...
		$orderedids = array();

		switch ($_REQUEST['do']){
			case 'latestthreads':
				$posts = $db->query_read("
					SELECT *
					FROM " . TABLE_PREFIX . "post AS post
					INNER JOIN " . TABLE_PREFIX . "thread AS thread ON (thread.firstpostid = post.postid)
					WHERE thread.threadid > 0
					ORDER BY post.dateline DESC
					LIMIT " . ($vbulletin->options['maxresults'] * 2) . "
				");
				break;
			case 'mostviewedthreads':
				$posts = $db->query_read("
					SELECT *
					FROM " . TABLE_PREFIX . "post AS post
					INNER JOIN " . TABLE_PREFIX . "thread AS thread ON (thread.firstpostid = post.postid)
					WHERE thread.threadid > 0
					ORDER BY thread.views DESC
					LIMIT " . ($vbulletin->options['maxresults'] * 2) . "
				");
				break;
			case 'hottestthreads':
				$posts = $db->query_read("
					SELECT *
					FROM " . TABLE_PREFIX . "post AS post
					INNER JOIN " . TABLE_PREFIX . "thread AS thread ON (thread.firstpostid = post.postid)
					WHERE thread.threadid > 0
					ORDER BY thread.replycount DESC
					LIMIT " . ($vbulletin->options['maxresults'] * 2) . "
				");
				break;
			case 'latestpolls':
				$posts = $db->query_read("
					SELECT *
					FROM " . TABLE_PREFIX . "post AS post
					INNER JOIN " . TABLE_PREFIX . "thread AS thread ON (thread.firstpostid = post.postid)
					WHERE thread.pollid > 0
					ORDER BY post.dateline DESC
					LIMIT " . ($vbulletin->options['maxresults'] * 2) . "
				");
				break;
			case 'mostviewedpolls':
				$posts = $db->query_read("
					SELECT *
					FROM " . TABLE_PREFIX . "post AS post
					INNER JOIN " . TABLE_PREFIX . "thread AS thread ON (thread.firstpostid = post.postid)
					WHERE thread.pollid > 0
					ORDER BY thread.views DESC
					LIMIT " . ($vbulletin->options['maxresults'] * 2) . "
				");
				break;
			case 'hottestpolls':
				$posts = $db->query_read("
					SELECT *
					FROM " . TABLE_PREFIX . "post AS post
					INNER JOIN " . TABLE_PREFIX . "thread AS thread ON (thread.firstpostid = post.postid)
					WHERE thread.pollid > 0
					ORDER BY thread.replycount DESC
					LIMIT " . ($vbulletin->options['maxresults'] * 2) . "
				");
				break;
			case 'latestposts':
				$posts = $db->query_read("
					SELECT *
					FROM " . TABLE_PREFIX . "post AS post
					INNER JOIN " . TABLE_PREFIX . "thread AS thread ON (thread.threadid = post.threadid)
					WHERE thread.threadid > 0
					ORDER BY post.dateline DESC
					LIMIT " . ($vbulletin->options['maxresults'] * 2) . "
				");
				break;
			case 'mostthankedposts':
				$posts = $db->query_read("
					SELECT *
					FROM " . TABLE_PREFIX . "post AS post
					INNER JOIN " . TABLE_PREFIX . "thread AS thread ON (thread.threadid = post.threadid)
					WHERE thread.threadid > 0
					ORDER BY post.post_thanks_amount DESC
					LIMIT " . ($vbulletin->options['maxresults'] * 2) . "
				");
				break;
			default: break;
		}

		while ($post = $db->fetch_array($posts))
		{
			$orderedids[] = $post['postid'];
		}
		unset($post);
		$db->free_result($posts);

		// did we get some results?
		if (empty($orderedids))
		{
			eval(standard_error(fetch_error('searchnoresults', $displayCommon), '', false));
		}

		// set display terms
		$display = array(
			'words' => array(),
			'highlight' => array(),
			'common' => array(),
			'users' => array($user['userid'] => $user['username']),
			'forums' => iif($showforums, $display['forums'], 0),
			'options' => array(
				'starteronly' => 0,
				'childforums' => 1,
				'action' => 'process'
			)
		);

		// end search timer
		$searchtime = number_format(fetch_microtime_difference($searchtime), 5, '.', '');

		/*insert query*/
		$db->query_write("
			REPLACE INTO " . TABLE_PREFIX . "search (userid, ipaddress, personal, searchuser, forumchoice, sortby, sortorder, searchtime, showposts, orderedids, dateline, displayterms, searchhash)
			VALUES (" . $vbulletin->userinfo['userid'] . ", '" . $db->escape_string(IPADDRESS) . "', 1, '" . $db->escape_string($user['username']) . "', '" . $db->escape_string($forumchoice) . "', 'post.dateline', 'DESC', $searchtime, 1, '" . $db->escape_string(implode(',', $orderedids)) . "', " . TIMENOW . ", '" . $db->escape_string(serialize($display)) . "', '" . $db->escape_string($searchhash) . "')
		");
		$searchid = $db->insert_id();

		$vbulletin->url = 'search.php?' . $vbulletin->session->vars['sessionurl'] . "searchid=$searchid";
		eval(print_standard_redirect('search'));
	}
}


if ($_REQUEST['do'] == 'tag'){

	$show[sidebar_tagcloud] = false;
	if ($vbulletin->options['vb4sidebar_tagcloud']) {
		$show[sidebar_tagcloud] = true;

		require_once(DIR . '/includes/functions.php');

		$tags = array();
		if ($vbulletin->options['tagcloud_usergroup'] > 0 AND !isset($vbulletin->usergroupcache[$vbulletin->options['tagcloud_usergroup']])){
			// handle a usergroup being deleted: default to live permission checking
			$vbulletin->options['tagcloud_usergroup'] = -1;
		}

		if ($vbulletin->options['vb4sidebar_tags_type'] == '1'){
			$vb4sidebar_tagstype = 1;
		}
		else{
			$vb4sidebar_tagstype = 2;
		}

		$cacheable = ($vbulletin->options['tagcloud_usergroup'] != -1);
		if (!$cacheable){
			$cloud = null;
		}
		else{
			switch ($vbulletin->options['vb4sidebar_tags_type']){
				case '2':
					$cloud = $vbulletin->searchcloud;
					break;
				case '1':
				default:
					$cloud = $vbulletin->tagcloud;
					break;
			}
		}

		if (!is_array($cloud) OR $cloud['dateline'] < (TIMENOW - (60 * $vbulletin->options['tagcloud_cachetime']))){
			if ($vbulletin->options['vb4sidebar_tags_type'] == 'search'){
				$tags_result = $vbulletin->db->query_read_slave("
					SELECT tagsearch.tagid, tag.tagtext, COUNT(*) AS searchcount
					FROM " . TABLE_PREFIX . "tagsearch AS tagsearch
					INNER JOIN " . TABLE_PREFIX . "tag AS tag ON (tagsearch.tagid = tag.tagid)
						" . ($vbulletin->options['tagcloud_searchhistory'] ?
					"WHERE tagsearch.dateline > " . (TIMENOW - (60 * 60 * 24 * $vbulletin->options['tagcloud_searchhistory'])) :
						'') . "
					GROUP BY tagsearch.tagid, tag.tagtext
					ORDER BY searchcount DESC
					LIMIT " . $vbulletin->options['tagcloud_tags']
				);
			}
			else{
				if (!$vbulletin->options['tagcloud_usergroup']){
					$perm_limit = false;
				}
				else{
					$forums = array();
					$perm_limit = true;

					foreach ($vbulletin->forumcache AS $forumid => $forum){
						// -1 for live permission checking
						$perm_array = ($vbulletin->options['tagcloud_usergroup'] == -1
							? $vbulletin->userinfo['forumpermissions']["$forumid"]
							: $forum['permissions'][$vbulletin->options['tagcloud_usergroup']]
						);

						if ($perm_array & $vbulletin->bf_ugp_forumpermissions['canview']
							AND $perm_array & $vbulletin->bf_ugp_forumpermissions['canviewthreads']
							AND $perm_array & $vbulletin->bf_ugp_forumpermissions['canviewothers']
						){
							$forums[] = intval($forumid);
						}
					}
				}

				if (!$perm_limit OR $forums){
					$tags_result = $vbulletin->db->query_read_slave("
						SELECT tagthread.tagid, tag.tagtext, COUNT(*) AS searchcount
						FROM " . TABLE_PREFIX . "tagthread AS tagthread
						INNER JOIN " . TABLE_PREFIX . "tag AS tag ON (tagthread.tagid = tag.tagid)
						INNER JOIN " . TABLE_PREFIX . "thread AS thread ON (tagthread.threadid = thread.threadid)
						WHERE thread.open <> 10
							AND thread.visible = 1
						" . ($perm_limit ? "AND thread.forumid IN (" . implode(',', $forums) . ")" : '') . "
						" . ($vbulletin->options['tagcloud_usagehistory'] ?
							"AND tagthread.dateline > " . (TIMENOW - (60 * 60 * 24 * $vbulletin->options['tagcloud_usagehistory'])) :
							'') . "
						GROUP BY tagthread.tagid, tag.tagtext
						ORDER BY searchcount DESC
						LIMIT " . $vbulletin->options['tagcloud_tags']
					);
				}
			}

			while ($currenttag = $vbulletin->db->fetch_array($tags_result)){
				$tags["$currenttag[tagtext]"] = $currenttag;
				$totals[$currenttag['tagid']] = $currenttag['searchcount'];
			}

			// fetch the stddev levels
			//$levels = fetch_standard_deviated_levels($totals, $vbulletin->options['tagcloud_levels']);

			if (!$count = sizeof($totals)){
				$levels = array();
			}
			else{
				$total = $summation = 0;
				$results = array();

				// calculate the total
				foreach ($totals AS $value){
					$total += $value;
				}

				// calculate the mean
				$mean = $total / $count;

				// calculate the summation
				foreach ($totals AS $id => $value){
					$summation += pow(($value - $mean), 2);
				}

				$sd = sqrt($summation / $count);

				if ($sd){
					$sdvalues = array();
					$lowestsds = 0;
					$highestsds = 0;

					// find the max and min standard deviations
					foreach ($totals AS $id => $value){
						$value = (($value - $mean) / $sd);
						$totals[$id] = $value;
						$lowestsds = min($value, $lowestsds);
						$highestsds = max($value, $highestsds);
					}

					foreach ($totals AS $id => $value){
						// normalize the std devs to 0 - 1, then map back to 1 - #levls
						$totals[$id] = round((($value - $lowestsds) / ($highestsds - $lowestsds)) * ($vbulletin->options['tagcloud_levels'] - 1)) + 1;
					}
				}
				else{
					foreach ($totals AS $id => $value){
						$totals[$id] = round($vbulletin->options['tagcloud_levels'] / 2);
					}
				}
	
				$levels = $totals;
			}

			// assign the levels back to the tags
			foreach ($tags AS $tagtext => $tag){
				$tags[$tagtext]['level'] = $levels[$tag['tagid']];
				$tags[$tagtext]['tagtext_url'] = urlencode(unhtmlspecialchars($tag['tagtext']));
			}

			// sort the categories by title
			uksort($tags, 'strnatcasecmp');

			$cloud = array(
				'tags' => $tags,
				'count' => sizeof($tags),
				'dateline' => TIMENOW
			);

			if ($cacheable){
				if ($vbulletin->options['vb4sidebar_tags_type'] == 'search'){
					$vbulletin->searchcloud = $cloud;
					build_datastore('searchcloud', serialize($cloud), 1);
				}
				else{
					$vbulletin->tagcloud = $cloud;
					build_datastore('tagcloud', serialize($cloud), 1);
				}
			}
		}

		if (empty($cloud['tags'])){
			$cumulustagcloud = '';
			$nbtags = 0;
		}
		else{
			$i = -1;
			$cloud_links = '';
			foreach ($cloud['tags'] AS $thistag){
				$i++;
				$cumulustagcloud[$i][tagtext_url] = $thistag[tagtext_url];
				$cumulustagcloud[$i][level] = $thistag[level];
				$cumulustagcloud[$i][tagtext] = $thistag[tagtext];
								
				$cloud_links .= '<a href="tags.php?'.$vbulletin->session->vars[sessionurl].'tag='.$thistag[tagtext_url].'" class="tagcloudlink level'.$thistag[level].'">'.$thistag[tagtext].'</a>';
			}
			$nbtags = $i;
		}

		if (!(empty($cumulustagcloud))){
			$iMax = $nbtags;

			if ($nbtags > $vbulletin->options['vb4sidebar_maxtags']){
				$iMax = $vbulletin->options['vb4sidebar_maxtags'];
			}

			$vbcumuluswidget_tagcloud = '%3Ctags%3E';

			for ($i = 0; $i < $iMax; $i++) {

				$j = rand(2,$nbtags);
				$cumulustag_tagtext = $cumulustagcloud[$j][tagtext];
				$cumulustag_level = intval($cumulustagcloud[$j][level]);
				$cumulustag_link = 'tags.php?'.$vbulletin->session->vars[sessionurl].'tag='.$cumulustagcloud[$j][tagtext_url];

				switch ($cumulustag_level){
					case "1": $fontsize = '9'; break;
					case "2": $fontsize = '11'; break;
					case "3": $fontsize = '13'; break;
					case "4": $fontsize = '15'; break;
					case "5": $fontsize = '17'; break;
				}

				$taglink = urlencode($cumulustag_link);
				$tagtext = urlencode($cumulustag_tagtext);
				if (!(empty($fontsize))){
					$vbcumuluswidget_tagcloud .= '%3Ca+href%3D%27'.$taglink.'%27+rel%3D%22tag%22+style%3D%27font-size%3A+'.$fontsize.'pt%3B%27%3E'.$tagtext.'%3C%2Fa%3E%0A';
				}
			}
			$vbcumuluswidget_tagcloud .= '%3C%2Ftags%3E';
		}
		else{
			$tagtext = urlencode($vbphrase['vb4sidebar_no_tag_found']);
			$vbcumuluswidget_tagcloud = '%3Ctags%3E';

			for($i = 0; $i < $vbulletin->options['vb4sidebar_maxtags']; $i++) {
				// Create randomizer
				// Use switch statement to find font size
				$randomizer = rand(1,5);
				switch ($randomizer){
					case "1": $fontsize = '9'; break;
					case "2": $fontsize = '11'; break;
					case "3": $fontsize = '13'; break;
					case "4": $fontsize = '15'; break;
					case "5": $fontsize = '17'; break;
				}
				$vbcumuluswidget_tagcloud .= '%3Ca+href%3D%27%23%27+rel%3D%22tag%22+style%3D%27font-size%3A+'.$fontsize.'pt%3B%27%3E'.$tagtext.'%3C%2Fa%3E%0A';
			}
			$vbcumuluswidget_tagcloud .= '%3C%2Ftags%3E';
		}

		// add random seeds to so name and movie url to avoid collisions and force reloading (needed for IE)
		$vbcumuluswidget_soname = 'widget_so_' . rand(0,9999999);
		$vbcumuluswidget_movie = $vbulletin->options[bburl].'/clientscript/vb_cumulus/tagcloud.swf?r=' . rand(0,9999999);
		$vbcumuluswidget_div_id = 'vbcumuluswidgetcontent' . rand(0,9999999);

		// navbar and final output
						
		$navbits = construct_navbits(array('','',
			'' => ($vbphrase[vb4sidebar_tag_cloud_title])
		));

		eval('$navbar = "' . fetch_template('navbar') . '";');
		eval('print_output("' . fetch_template('vb4sidebar_tagcloud_page') . '");');
	}
}


function get_attachments_data($orderby){
	global $vbulletin, $stylevar, $vbphrase;

	$limitread = $vbulletin->options[vb4sidebar_items_per_block];

	$attachments = $vbulletin->db->query_read("
		SELECT attachment.attachmentid, attachment.postid, attachment.userid, attachment.dateline, attachment.counter
		FROM " . TABLE_PREFIX . "attachment AS attachment
		INNER JOIN " . TABLE_PREFIX . "post AS post ON(post.postid = attachment.postid)
		WHERE post.postid > 0
		ORDER BY attachment.$orderby DESC
		LIMIT ".$limitread."
	");

	$sidebar_block_attachments_bits = '';

	$sidebar_block_bits = '';
	while ($arraydata = $vbulletin->db->fetch_array($attachments)){

		$userid = $arraydata[userid];
		$userinfo = $vbulletin->db->query_first("SELECT avatarid, avatarrevision FROM " . TABLE_PREFIX . "user WHERE userid = " . $userid . "");
		$postread = $vbulletin->db->query_first("SELECT threadid, username FROM " . TABLE_PREFIX . "post WHERE postid = " . $arraydata[postid] . "");
		$threadread = $vbulletin->db->query_first("SELECT title FROM " . TABLE_PREFIX . "thread WHERE threadid = " . $postread[threadid] . "");

		if ($userinfo['avatarid']){ 
			// using a predefined avatar 
			$avatar = $vbulletin->db->query_first("SELECT avatarpath FROM " . TABLE_PREFIX . "avatar WHERE avatarid = " . $userinfo[avatarid] . ""); 
			$avatarurl = $vbulletin->options[bburl] . '/' . $avatar[avatarpath];
		} 
		else { 
			// not using a predefined avatar, check for custom 
			if ($avatar = $vbulletin->db->query_first("SELECT dateline FROM " . TABLE_PREFIX . "customavatar WHERE userid = " . $userid . "")){
				// using a custom avatar 
				$avatarurl = ($vbulletin->options['usefileavatar']) ? "" . $vbulletin->options[avatarurl] . "/avatar" . $userid . "_" . $userinfo[avatarrevision] . ".gif" : "" . $vbulletin->options[bburl] . "/image.php?u=" . $userid . "&amp;dateline=" . $avatar['dateline'] . "";
			} 
			else{ 
				// no avatar specified 
				$avatarurl = $stylevar[imgdir_misc] . '/nosidebaravatar.png';
			}
		}
	
		$sidebar_block_bit_avatar = $avatarurl;
		$sidebar_block_bit_linkto = 'showthread.php?t='.$postread[threadid].'&p='.$arraydata[postid];
		$sidebar_block_bit_title = $threadread[title];
		$sidebar_block_bit_author = $postread[username];
		$sidebar_block_bit_userid = $arraydata[userid];
		$sidebar_blockbit_date = vbdate($vbulletin->options['dateformat'], $arraydata['dateline'], true);
		if (strcmp($sidebar_blockbit_date,"Today")!=0 AND strcmp($sidebar_blockbit_date, "Yesterday")!=0){
			$sidebar_block_bit_date = construct_phrase($vbphrase[vb4sidebar_posted_on_x], $sidebar_blockbit_date);
		}
		else{
			$sidebar_block_bit_date = $sidebar_blockbit_date;
		}

		$sidebar_block_bits .= '<li class="avatarcontent floatcontainer">'.
						'	<a class="smallavatar">'.
						'		<img title="" src="'.$sidebar_block_bit_avatar.'" alt="" width="30">'.
						'	</a>'.
						'	<div class="smallavatartext">'.
						'		<a href="'.$sidebar_block_bit_linkto.'" class="title">'.$sidebar_block_bit_title.'</a>'.
						'		<div class="meta">'.
									construct_phrase($vbphrase[vb4sidebar_postedby_x_y_z_s], $sidebar_block_bit_author, $sidebar_block_bit_userid, $vbulletin->session->vars[sessionurl], $vbulletin->userinfo[securitytoken]).
						'			<br>'.$sidebar_block_bit_date .
						'		</div>'.
						'	</div>'.
						'</li>';
		}

	return $sidebar_block_bits;
}


function get_blog_data($orderby){
	global $vbulletin, $stylevar, $vbphrase;

	$limitread = $vbulletin->options[vb4sidebar_items_per_block];

	$blogentries = $vbulletin->db->query_read("
		SELECT blogid, username, userid, title, firstblogtextid, dateline
		FROM " . TABLE_PREFIX . "blog
		WHERE 1
		ORDER BY $orderby DESC
		LIMIT ".$limitread."
	");
	
	$sidebar_block_blog_bits = '';

	$sidebar_block_bits = '';
	while ($arraydata = $vbulletin->db->fetch_array($blogentries)){
		$userid = $arraydata[userid];
		$userinfo = $vbulletin->db->query_first("SELECT avatarid, avatarrevision FROM " . TABLE_PREFIX . "user WHERE userid = " . $userid . "");
		$blogread = $vbulletin->db->query_first("SELECT title FROM " . TABLE_PREFIX . "blog_text WHERE blogtextid = " . $arraydata[firstblogtextid] . "");

		if ($userinfo['avatarid']){ 
			// using a predefined avatar 
			$avatar = $vbulletin->db->query_first("SELECT avatarpath FROM " . TABLE_PREFIX . "avatar WHERE avatarid = " . $userinfo[avatarid] . ""); 
			$avatarurl = $vbulletin->options[bburl] . '/' . $avatar[avatarpath];
		} 
		else { 
			// not using a predefined avatar, check for custom 
			if ($avatar = $vbulletin->db->query_first("SELECT dateline FROM " . TABLE_PREFIX . "customavatar WHERE userid = " . $userid . "")){
				// using a custom avatar 
				$avatarurl = ($vbulletin->options['usefileavatar']) ? "" . $vbulletin->options[avatarurl] . "/avatar" . $userid . "_" . $userinfo[avatarrevision] . ".gif" : "" . $vbulletin->options[bburl] . "/image.php?u=" . $userid . "&amp;dateline=" . $avatar['dateline'] . "";
			} 
			else{ 
				// no avatar specified 
				$avatarurl = $stylevar[imgdir_misc] . '/nosidebaravatar.png';
			}
		}
	
		$sidebar_block_bit_avatar = $avatarurl;
		$sidebar_block_bit_linkto = 'blog.php?b='.$arraydata[blogid];
		$sidebar_block_bit_title = $arraydata[title];
		$sidebar_block_bit_author = $arraydata[username];
		$sidebar_block_bit_userid = $arraydata[userid];
		$sidebar_blockbit_date = vbdate($vbulletin->options['dateformat'], $arraydata['dateline'], true);
		if (strcmp($sidebar_blockbit_date,"Today")!=0 AND strcmp($sidebar_blockbit_date, "Yesterday")!=0){
			$sidebar_block_bit_date = construct_phrase($vbphrase[vb4sidebar_posted_on_x], $sidebar_blockbit_date);
		}
		else{
			$sidebar_block_bit_date = $sidebar_blockbit_date;
		}

		$sidebar_block_bits .= '<li class="avatarcontent floatcontainer">'.
						'	<a class="smallavatar">'.
						'		<img title="" src="'.$sidebar_block_bit_avatar.'" alt="" width="30">'.
						'	</a>'.
						'	<div class="smallavatartext">'.
						'		<a href="'.$sidebar_block_bit_linkto.'" class="title">'.$sidebar_block_bit_title.'</a>'.
						'		<div class="meta">'.
									construct_phrase($vbphrase[vb4sidebar_postedby_x_y_z_s], $sidebar_block_bit_author, $sidebar_block_bit_userid, $vbulletin->session->vars[sessionurl], $vbulletin->userinfo[securitytoken]).
						'			<br>'.$sidebar_block_bit_date .
						'		</div>'.
						'	</div>'.
						'</li>';
	}

	return $sidebar_block_bits;
}


function get_slideshows_data($orderby){
	global $vbulletin, $stylevar, $vbphrase;

	$limitread = $vbulletin->options[vb4sidebar_items_per_block];

	foreach ($vbulletin->forumcache AS $forumid => $forum){
		$fperms =& $vbulletin->userinfo['forumpermissions']["$forumid"];
		if (($fperms & $vbulletin->bf_ugp_forumpermissions['canview'])){
			$forumids[] = $forumid;
		}
	}
	$showforums = false;

	if (empty($forumids)){
		eval(standard_error(fetch_error('searchnoresults', $displayCommon), '', false));
	}
	else{
		$threads = $vbulletin->db->query_read("
			SELECT threadid, forumid, postusername, postuserid, title, firstpostid, slideshowid, dateline
			FROM " . TABLE_PREFIX . "thread
			WHERE slideshowid > 0 AND forumid IN(" . implode(',', $forumids) . ")
			ORDER BY $orderby DESC
			LIMIT ".$limitread."
		");

		$sidebar_block_threads_bits = '';
		
		$sidebar_block_bits = '';
		while ($arraydata = $vbulletin->db->fetch_array($threads)){
			$userid = $arraydata[postuserid];
			$userinfo = $vbulletin->db->query_first("SELECT avatarid, avatarrevision FROM " . TABLE_PREFIX . "user WHERE userid = " . $userid . "");

			if ($userinfo['avatarid']){ 
				// using a predefined avatar 
				$avatar = $vbulletin->db->query_first("SELECT avatarpath FROM " . TABLE_PREFIX . "avatar WHERE avatarid = " . $userinfo[avatarid] . ""); 
				$avatarurl = $vbulletin->options[bburl] . '/' . $avatar[avatarpath];
			} 
			else { 
				// not using a predefined avatar, check for custom 
				if ($avatar = $vbulletin->db->query_first("SELECT dateline FROM " . TABLE_PREFIX . "customavatar WHERE userid = " . $userid . "")){
					// using a custom avatar 
					$avatarurl = ($vbulletin->options['usefileavatar']) ? "" . $vbulletin->options[avatarurl] . "/avatar" . $userid . "_" . $userinfo[avatarrevision] . ".gif" : "" . $vbulletin->options[bburl] . "/image.php?u=" . $userid . "&amp;dateline=" . $avatar['dateline'] . "";
				} 
				else{ 
					// no avatar specified 
					$avatarurl = $stylevar[imgdir_misc] . '/nosidebaravatar.png';
				}
			}
	
			$sidebar_block_bit_avatar = $avatarurl;
			$sidebar_block_bit_linkto = 'showthread.php?t='.$arraydata[threadid];
			$sidebar_block_bit_title = $arraydata[title];
			$sidebar_block_bit_author = $arraydata[postusername];
			$sidebar_block_bit_userid = $arraydata[postuserid];
			$sidebar_blockbit_date = vbdate($vbulletin->options['dateformat'], $arraydata['dateline'], true);
			if (strcmp($sidebar_blockbit_date,"Today")!=0 AND strcmp($sidebar_blockbit_date, "Yesterday")!=0){
				$sidebar_block_bit_date = construct_phrase($vbphrase[vb4sidebar_posted_on_x], $sidebar_blockbit_date);
			}
			else{
				$sidebar_block_bit_date = $sidebar_blockbit_date;
			}
	
			$sidebar_block_bits .= '<li class="avatarcontent floatcontainer">'.
							'	<a class="smallavatar">'.
							'		<img title="" src="'.$sidebar_block_bit_avatar.'" alt="" width="30">'.
							'	</a>'.
							'	<div class="smallavatartext">'.
							'		<a href="'.$sidebar_block_bit_linkto.'" class="title">'.$sidebar_block_bit_title.'</a>'.
							'		<div class="meta">'.
										construct_phrase($vbphrase[vb4sidebar_postedby_x_y_z_s], $sidebar_block_bit_author, $sidebar_block_bit_userid, $vbulletin->session->vars[sessionurl], $vbulletin->userinfo[securitytoken]).
							'			<br>'.$sidebar_block_bit_date .
							'		</div>'.
							'	</div>'.
							'</li>';
		}
	}

	return $sidebar_block_bits;
}

function get_albums_data($orderby){
	global $vbulletin, $stylevar, $vbphrase;

	$limitread = $vbulletin->options[vb4sidebar_items_per_block];

	$albums = $vbulletin->db->query_read("
		SELECT albumid, userid, title, createdate
		FROM " . TABLE_PREFIX . "album
		WHERE 1
		ORDER BY $orderby DESC
		LIMIT ".$limitread."
	");

	$sidebar_block_albums_bits = '';

	$sidebar_block_bits = '';
	while ($arraydata = $vbulletin->db->fetch_array($albums)){
		$userid = $arraydata[userid];
		$userinfo = $vbulletin->db->query_first("SELECT username, avatarid, avatarrevision FROM " . TABLE_PREFIX . "user WHERE userid = " . $userid . "");

		if ($userinfo['avatarid']){ 
			// using a predefined avatar 
			$avatar = $vbulletin->db->query_first("SELECT avatarpath FROM " . TABLE_PREFIX . "avatar WHERE avatarid = " . $userinfo[avatarid] . ""); 
			$avatarurl = $vbulletin->options[bburl] . '/' . $avatar[avatarpath];
		} 
		else { 
			// not using a predefined avatar, check for custom 
			if ($avatar = $vbulletin->db->query_first("SELECT dateline FROM " . TABLE_PREFIX . "customavatar WHERE userid = " . $userid . "")){
				// using a custom avatar 
				$avatarurl = ($vbulletin->options['usefileavatar']) ? "" . $vbulletin->options[avatarurl] . "/avatar" . $userid . "_" . $userinfo[avatarrevision] . ".gif" : "" . $vbulletin->options[bburl] . "/image.php?u=" . $userid . "&amp;dateline=" . $avatar['dateline'] . "";
			} 
			else{ 
				// no avatar specified 
				$avatarurl = $stylevar[imgdir_misc] . '/nosidebaravatar.png';
			}
		}

		$sidebar_block_bit_avatar = $avatarurl;
		$sidebar_block_bit_linkto = 'album.php?albumid='.$arraydata[albumid];
		$sidebar_block_bit_title = $arraydata[title];
		$sidebar_block_bit_author = $userinfo[username];
		$sidebar_block_bit_userid = $arraydata[userid];
		$sidebar_blockbit_date = vbdate($vbulletin->options['dateformat'], $arraydata['createdate'], true);
		if (strcmp($sidebar_blockbit_date,"Today")!=0 AND strcmp($sidebar_blockbit_date, "Yesterday")!=0){
			$sidebar_block_bit_date = construct_phrase($vbphrase[vb4sidebar_posted_on_x], $sidebar_blockbit_date);
		}
		else{
			$sidebar_block_bit_date = $sidebar_blockbit_date;
		}

		$sidebar_block_bits .= '<li class="avatarcontent floatcontainer">'.
						'	<a class="smallavatar">'.
						'		<img title="" src="'.$sidebar_block_bit_avatar.'" alt="" width="30">'.
						'	</a>'.
						'	<div class="smallavatartext">'.
						'		<a href="'.$sidebar_block_bit_linkto.'" class="title">'.$sidebar_block_bit_title.'</a>'.
						'		<div class="meta">'.
									construct_phrase($vbphrase[vb4sidebar_postedby_x_y_z_s], $sidebar_block_bit_author, $sidebar_block_bit_userid, $vbulletin->session->vars[sessionurl], $vbulletin->userinfo[securitytoken]).
						'			<br>'.$sidebar_block_bit_date .
						'		</div>'.
						'	</div>'.
						'</li>';
	}

	return $sidebar_block_bits;
}

function get_members_data($orderby){
	global $vbulletin, $stylevar, $vbphrase;

	$limitread = $vbulletin->options[vb4sidebar_items_per_block];

	$members = $vbulletin->db->query_read("
		SELECT userid, username, joindate, avatarid, avatarrevision
		FROM " . TABLE_PREFIX . "user
		WHERE 1
		ORDER BY $orderby DESC
		LIMIT ".$limitread."
	");

	$sidebar_block_members_bits = '';
	
	$sidebar_block_bits = '';
	while ($arraydata = $vbulletin->db->fetch_array($members)){
		$userid = $arraydata[userid];

		if ($arraydata['avatarid']){ 
			// using a predefined avatar 
			$avatar = $vbulletin->db->query_first("SELECT avatarpath FROM " . TABLE_PREFIX . "avatar WHERE avatarid = " . $arraydata[avatarid] . ""); 
			$avatarurl = $vbulletin->options[bburl] . '/' . $avatar[avatarpath];
		} 
		else { 
			// not using a predefined avatar, check for custom 
			if ($avatar = $vbulletin->db->query_first("SELECT dateline FROM " . TABLE_PREFIX . "customavatar WHERE userid = " . $userid . "")){
				// using a custom avatar 
				$avatarurl = ($vbulletin->options['usefileavatar']) ? "" . $vbulletin->options[avatarurl] . "/avatar" . $userid . "_" . $arraydata[avatarrevision] . ".gif" : "" . $vbulletin->options[bburl] . "/image.php?u=" . $userid . "&amp;dateline=" . $avatar['dateline'] . "";
			} 
			else{ 
				// no avatar specified 
				$avatarurl = $stylevar[imgdir_misc] . '/nosidebaravatar.png';
			}
		}

		$sidebar_block_bit_avatar = $avatarurl;
		$sidebar_block_bit_linkto = 'member.php?'.$vbulletin->session->vars[sessionurl].'u='.$arraydata[userid].'&s='.$vbulletin->userinfo[securitytoken];
		$sidebar_block_bit_title = $arraydata[username];
		$sidebar_block_bit_author = $arraydata[username];
		$sidebar_block_bit_userid = $arraydata[userid];
		$sidebar_blockbit_date = vbdate($vbulletin->options['dateformat'], $arraydata['joindate'], true);
		if (strcmp($sidebar_blockbit_date,"Today")!=0 AND strcmp($sidebar_blockbit_date, "Yesterday")!=0){
			$sidebar_block_bit_date = construct_phrase($vbphrase[vb4sidebar_joined_on_x], $sidebar_blockbit_date);
		}
		else{
			$sidebar_block_bit_date = construct_phrase($vbphrase[vb4sidebar_joined_x], $sidebar_blockbit_date);
		}

		$sidebar_block_bits .= '<li class="avatarcontent floatcontainer">'.
						'	<a class="smallavatar">'.
						'		<img title="" src="'.$sidebar_block_bit_avatar.'" alt="" width="30">'.
						'	</a>'.
						'	<div class="smallavatartext">'.
						'		<a href="'.$sidebar_block_bit_linkto.'" class="title">'.$sidebar_block_bit_title.'</a>'.
						'		<div class="meta">'.
									$sidebar_block_bit_date .
						'		</div>'.
						'	</div>'.
						'</li>';
	}

	return $sidebar_block_bits;
}

function get_socialgroups_data($orderby){
	global $vbulletin, $stylevar, $vbphrase;

	$limitread = $vbulletin->options[vb4sidebar_items_per_block];

	$socialgroups = $vbulletin->db->query_read("
		SELECT groupid, creatoruserid, name, dateline
		FROM " . TABLE_PREFIX . "socialgroup
		WHERE 1
		ORDER BY $orderby DESC
		LIMIT ".$limitread."
	");

	$sidebar_block_socialgroups_bits = '';

	$sidebar_block_bits = '';
	while ($arraydata = $vbulletin->db->fetch_array($socialgroups)){
		$userid = $arraydata[creatoruserid];
		$userinfo = $vbulletin->db->query_first("SELECT username, avatarid, avatarrevision FROM " . TABLE_PREFIX . "user WHERE userid = " . $userid . "");

		if ($userinfo['avatarid']){ 
			// using a predefined avatar 
			$avatar = $vbulletin->db->query_first("SELECT avatarpath FROM " . TABLE_PREFIX . "avatar WHERE avatarid = " . $userinfo[avatarid] . ""); 
			$avatarurl = $vbulletin->options[bburl] . '/' . $avatar[avatarpath];
		} 
		else { 
			// not using a predefined avatar, check for custom 
			if ($avatar = $vbulletin->db->query_first("SELECT dateline FROM " . TABLE_PREFIX . "customavatar WHERE userid = " . $userid . "")){
				// using a custom avatar 
				$avatarurl = ($vbulletin->options['usefileavatar']) ? "" . $vbulletin->options[avatarurl] . "/avatar" . $userid . "_" . $userinfo[avatarrevision] . ".gif" : "" . $vbulletin->options[bburl] . "/image.php?u=" . $userid . "&amp;dateline=" . $avatar['dateline'] . "";
			} 
			else{ 
				// no avatar specified 
				$avatarurl = $stylevar[imgdir_misc] . '/nosidebaravatar.png';
			}
		}

		$sidebar_block_bit_avatar = $avatarurl;
		$sidebar_block_bit_linkto = 'group.php?groupid='.$arraydata[groupid];
		$sidebar_block_bit_title = $arraydata[name];
		$sidebar_block_bit_author = $userinfo[username];
		$sidebar_block_bit_userid = $arraydata[creatoruserid];
		$sidebar_blockbit_date = vbdate($vbulletin->options['dateformat'], $arraydata['dateline'], true);
		if (strcmp($sidebar_blockbit_date,"Today")!=0 AND strcmp($sidebar_blockbit_date, "Yesterday")!=0){
			$sidebar_block_bit_date = construct_phrase($vbphrase[vb4sidebar_posted_on_x], $sidebar_blockbit_date);
		}
		else{
			$sidebar_block_bit_date = $sidebar_blockbit_date;
		}

		$sidebar_block_bits .= '<li class="avatarcontent floatcontainer">'.
						'	<a class="smallavatar">'.
						'		<img title="" src="'.$sidebar_block_bit_avatar.'" alt="" width="30">'.
						'	</a>'.
						'	<div class="smallavatartext">'.
						'		<a href="'.$sidebar_block_bit_linkto.'" class="title">'.$sidebar_block_bit_title.'</a>'.
						'		<div class="meta">'.
									construct_phrase($vbphrase[vb4sidebar_postedby_x_y_z_s], $sidebar_block_bit_author, $sidebar_block_bit_userid, $vbulletin->session->vars[sessionurl], $vbulletin->userinfo[securitytoken]).
						'			<br>'.$sidebar_block_bit_date .
						'		</div>'.
						'	</div>'.
					'</li>';
	}

	return $sidebar_block_bits;
}

function get_threads_data($orderby){
	global $vbulletin, $stylevar, $vbphrase;

	$limitread = $vbulletin->options[vb4sidebar_items_per_block];

	foreach ($vbulletin->forumcache AS $forumid => $forum){
		$fperms =& $vbulletin->userinfo['forumpermissions']["$forumid"];
		if (($fperms & $vbulletin->bf_ugp_forumpermissions['canview'])){
			$forumids[] = $forumid;
		}
	}
	$showforums = false;

	if (empty($forumids)){
		eval(standard_error(fetch_error('searchnoresults', $displayCommon), '', false));
	}
	else{
		$threads = $vbulletin->db->query_read("
			SELECT threadid, forumid, postusername, postuserid, title, firstpostid, dateline
			FROM " . TABLE_PREFIX . "thread
			WHERE forumid IN(" . implode(',', $forumids) . ")
			ORDER BY $orderby DESC
			LIMIT ".$limitread."
		");

		$sidebar_block_threads_bits = '';
	
		$sidebar_block_bits = '';
		while ($arraydata = $vbulletin->db->fetch_array($threads)){
			$userid = $arraydata[postuserid];
			$userinfo = $vbulletin->db->query_first("SELECT avatarid, avatarrevision FROM " . TABLE_PREFIX . "user WHERE userid = " . $userid . "");

			if ($userinfo['avatarid']){ 
				// using a predefined avatar 
				$avatar = $vbulletin->db->query_first("SELECT avatarpath FROM " . TABLE_PREFIX . "avatar WHERE avatarid = " . $userinfo[avatarid] . ""); 
				$avatarurl = $vbulletin->options[bburl] . '/' . $avatar[avatarpath];
			} 
			else { 
				// not using a predefined avatar, check for custom 
				if ($avatar = $vbulletin->db->query_first("SELECT dateline FROM " . TABLE_PREFIX . "customavatar WHERE userid = " . $userid . "")){
					// using a custom avatar 
					$avatarurl = ($vbulletin->options['usefileavatar']) ? "" . $vbulletin->options[avatarurl] . "/avatar" . $userid . "_" . $userinfo[avatarrevision] . ".gif" : "" . $vbulletin->options[bburl] . "/image.php?u=" . $userid . "&amp;dateline=" . $avatar['dateline'] . "";
				} 
				else{ 
					// no avatar specified 
					$avatarurl = $stylevar[imgdir_misc] . '/nosidebaravatar.png';
				}
			}

			$sidebar_block_bit_avatar = $avatarurl;
			$sidebar_block_bit_linkto = 'showthread.php?t='.$arraydata[threadid];
			$sidebar_block_bit_title = $arraydata[title];
			$sidebar_block_bit_author = $arraydata[postusername];
			$sidebar_block_bit_userid = $arraydata[postuserid];
			$sidebar_blockbit_date = vbdate($vbulletin->options['dateformat'], $arraydata['dateline'], true);
			if (strcmp($sidebar_blockbit_date,"Today")!=0 AND strcmp($sidebar_blockbit_date, "Yesterday")!=0){
				$sidebar_block_bit_date = construct_phrase($vbphrase[vb4sidebar_posted_on_x], $sidebar_blockbit_date);
			}
			else{
				$sidebar_block_bit_date = $sidebar_blockbit_date;
			}
	
			$sidebar_block_bits .= '<li class="avatarcontent floatcontainer">'.
							'	<a class="smallavatar">'.
							'		<img title="" src="'.$sidebar_block_bit_avatar.'" alt="" width="30">'.
							'	</a>'.
							'	<div class="smallavatartext">'.
							'		<a href="'.$sidebar_block_bit_linkto.'" class="title">'.$sidebar_block_bit_title.'</a>'.
							'		<div class="meta">'.
										construct_phrase($vbphrase[vb4sidebar_postedby_x_y_z_s], $sidebar_block_bit_author, $sidebar_block_bit_userid, $vbulletin->session->vars[sessionurl], $vbulletin->userinfo[securitytoken]).
							'			<br>'.$sidebar_block_bit_date .
							'		</div>'.
							'	</div>'.
							'</li>';
		}
	}

	return $sidebar_block_bits;
}

function get_posts_data($orderby){
	global $vbulletin, $stylevar, $vbphrase;

	$limitread = $vbulletin->options[vb4sidebar_items_per_block];

	foreach ($vbulletin->forumcache AS $forumid => $forum){
		$fperms =& $vbulletin->userinfo['forumpermissions']["$forumid"];
		if (($fperms & $vbulletin->bf_ugp_forumpermissions['canview'])){
			$forumids[] = $forumid;
		}
	}
	$showforums = false;

	if (empty($forumids)){
		eval(standard_error(fetch_error('searchnoresults', $displayCommon), '', false));
	}
	else{
		$posts = $vbulletin->db->query_read("
			SELECT post.postid, post.userid, post.username, post.threadid, post.dateline, thread.title
			FROM " . TABLE_PREFIX . "post AS post
			INNER JOIN " . TABLE_PREFIX . "thread AS thread ON(thread.threadid = post.threadid)
			WHERE thread.forumid IN(" . implode(',', $forumids) . ")
			ORDER BY post.$orderby DESC
			LIMIT ".$limitread."
		");

		$sidebar_block_posts_bits = '';
	
		$sidebar_block_bits = '';
		while ($arraydata = $vbulletin->db->fetch_array($posts)){
			$userid = $arraydata[userid];
			$userinfo = $vbulletin->db->query_first("SELECT avatarid, avatarrevision FROM " . TABLE_PREFIX . "user WHERE userid = " . $userid . "");

			if ($userinfo['avatarid']){ 
				// using a predefined avatar 
				$avatar = $vbulletin->db->query_first("SELECT avatarpath FROM " . TABLE_PREFIX . "avatar WHERE avatarid = " . $userinfo[avatarid] . ""); 
				$avatarurl = $vbulletin->options[bburl] . '/' . $avatar[avatarpath];
			} 
			else { 
				// not using a predefined avatar, check for custom 
				if ($avatar = $vbulletin->db->query_first("SELECT dateline FROM " . TABLE_PREFIX . "customavatar WHERE userid = " . $userid . "")){
					// using a custom avatar 
					$avatarurl = ($vbulletin->options['usefileavatar']) ? "" . $vbulletin->options[avatarurl] . "/avatar" . $userid . "_" . $userinfo[avatarrevision] . ".gif" : "" . $vbulletin->options[bburl] . "/image.php?u=" . $userid . "&amp;dateline=" . $avatar['dateline'] . "";
				} 
				else{ 
					// no avatar specified 
					$avatarurl = $stylevar[imgdir_misc] . '/nosidebaravatar.png';
				}
			}
	
			$sidebar_block_bit_avatar = $avatarurl;
			$sidebar_block_bit_linkto = 'showthread.php?t='.$arraydata[threadid].'&p='.$arraydata[postid];
			$sidebar_block_bit_title = construct_phrase($vbphrase[vb4sidebar_posted_in_x], $arraydata[title]);
			$sidebar_block_bit_author = $arraydata[username];
			$sidebar_block_bit_userid = $arraydata[userid];
			$sidebar_blockbit_date = vbdate($vbulletin->options['dateformat'], $arraydata['dateline'], true);
			if (strcmp($sidebar_blockbit_date,"Today")!=0 AND strcmp($sidebar_blockbit_date, "Yesterday")!=0){
				$sidebar_block_bit_date = construct_phrase($vbphrase[vb4sidebar_posted_on_x], $sidebar_blockbit_date);
			}
			else{
				$sidebar_block_bit_date = $sidebar_blockbit_date;
			}
		
			$sidebar_block_bits .= '<li class="avatarcontent floatcontainer">'.
							'	<a class="smallavatar">'.
							'		<img title="" src="'.$sidebar_block_bit_avatar.'" alt="" width="30">'.
							'	</a>'.
							'	<div class="smallavatartext">'.
							'		<a href="'.$sidebar_block_bit_linkto.'" class="title">'.$sidebar_block_bit_title.'</a>'.
							'		<div class="meta">'.
										construct_phrase($vbphrase[vb4sidebar_postedby_x_y_z_s], $sidebar_block_bit_author, $sidebar_block_bit_userid, $vbulletin->session->vars[sessionurl], $vbulletin->userinfo[securitytoken]).
							'			<br>'.$sidebar_block_bit_date .
							'		</div>'.
							'	</div>'.
							'</li>';
		}
	}

	return $sidebar_block_bits;
}

function get_polls_data($orderby){
	global $vbulletin, $stylevar, $vbphrase;

	$limitread = $vbulletin->options[vb4sidebar_items_per_block];

	foreach ($vbulletin->forumcache AS $forumid => $forum){
		$fperms =& $vbulletin->userinfo['forumpermissions']["$forumid"];
		if (($fperms & $vbulletin->bf_ugp_forumpermissions['canview'])){
			$forumids[] = $forumid;
		}
	}
	$showforums = false;

	if (empty($forumids)){
		eval(standard_error(fetch_error('searchnoresults', $displayCommon), '', false));
	}
	else{
		switch ($orderby){
			case 'dateline': 
				$polls = $vbulletin->db->query_read("
					SELECT poll.pollid, poll.question, poll.dateline, thread.postuserid, thread.threadid
					FROM " . TABLE_PREFIX . "poll as poll
					INNER JOIN " . TABLE_PREFIX . "thread AS thread ON(thread.pollid = poll.pollid)
					WHERE thread.forumid IN(" . implode(',', $forumids) . ")
					ORDER BY poll.dateline DESC
					LIMIT ".$limitread."
				");
				break;
			case 'views':
				$polls = $vbulletin->db->query_read("
					SELECT poll.pollid, poll.question, poll.dateline, thread.postuserid, thread.threadid
					FROM " . TABLE_PREFIX . "poll as poll
					INNER JOIN " . TABLE_PREFIX . "thread AS thread ON(thread.pollid = poll.pollid)
					WHERE thread.forumid IN(" . implode(',', $forumids) . ")
					ORDER BY thread.views DESC
					LIMIT ".$limitread."
				");
				break;
			case 'replycount':
				$polls = $vbulletin->db->query_read("
					SELECT poll.pollid, poll.question, poll.dateline, thread.postuserid, thread.threadid
					FROM " . TABLE_PREFIX . "poll as poll
					INNER JOIN " . TABLE_PREFIX . "thread AS thread ON(thread.pollid = poll.pollid)
					WHERE thread.forumid IN(" . implode(',', $forumids) . ")
					ORDER BY thread.replycount DESC
					LIMIT ".$limitread."
				");
				break;
			default: break;
		}

		$sidebar_block_polls_bits = '';

		$sidebar_block_bits = '';
		while ($arraydata = $vbulletin->db->fetch_array($polls)){
			$userid = $arraydata[postuserid];
			$userinfo = $vbulletin->db->query_first("SELECT username, avatarid, avatarrevision FROM " . TABLE_PREFIX . "user WHERE userid = " . $userid . "");
	
			if ($userinfo['avatarid']){ 
				// using a predefined avatar 
				$avatar = $vbulletin->db->query_first("SELECT avatarpath FROM " . TABLE_PREFIX . "avatar WHERE avatarid = " . $userinfo[avatarid] . ""); 
				$avatarurl = $vbulletin->options[bburl] . '/' . $avatar[avatarpath];
			} 
			else { 
				// not using a predefined avatar, check for custom 
				if ($avatar = $vbulletin->db->query_first("SELECT dateline FROM " . TABLE_PREFIX . "customavatar WHERE userid = " . $userid . "")){
					// using a custom avatar 
					$avatarurl = ($vbulletin->options['usefileavatar']) ? "" . $vbulletin->options[avatarurl] . "/avatar" . $userid . "_" . $userinfo[avatarrevision] . ".gif" : "" . $vbulletin->options[bburl] . "/image.php?u=" . $userid . "&amp;dateline=" . $avatar['dateline'] . "";
				} 
				else{ 
					// no avatar specified 
					$avatarurl = $stylevar[imgdir_misc] . '/nosidebaravatar.png';
				}
			}

			$sidebar_block_bit_avatar = $avatarurl;
			$sidebar_block_bit_linkto = 'showthread.php?t='.$arraydata[threadid];
			$sidebar_block_bit_title = $arraydata[question];
			$sidebar_block_bit_author = $userinfo[username];
			$sidebar_block_bit_userid = $arraydata[postuserid];
			$sidebar_blockbit_date = vbdate($vbulletin->options['dateformat'], $arraydata['dateline'], true);
			if (strcmp($sidebar_blockbit_date,"Today")!=0 AND strcmp($sidebar_blockbit_date, "Yesterday")!=0){
				$sidebar_block_bit_date = construct_phrase($vbphrase[vb4sidebar_posted_on_x], $sidebar_blockbit_date);
			}
			else{
				$sidebar_block_bit_date = $sidebar_blockbit_date;
			}
	
			$sidebar_block_bits .= '<li class="avatarcontent floatcontainer">'.
							'	<a class="smallavatar">'.
							'		<img title="" src="'.$sidebar_block_bit_avatar.'" alt="" width="30">'.
							'	</a>'.
							'	<div class="smallavatartext">'.
							'		<a href="'.$sidebar_block_bit_linkto.'" class="title">'.$sidebar_block_bit_title.'</a>'.
							'		<div class="meta">'.
										construct_phrase($vbphrase[vb4sidebar_postedby_x_y_z_s], $sidebar_block_bit_author, $sidebar_block_bit_userid, $vbulletin->session->vars[sessionurl], $vbulletin->userinfo[securitytoken]).
							'			<br>'.$sidebar_block_bit_date .
							'		</div>'.
							'	</div>'.
							'</li>';
		}
	}

	return $sidebar_block_bits;
}


function get_tagcloud_data(){
	global $vbulletin, $stylevar, $vbphrase;

	require_once(DIR . '/includes/functions.php');

	$tags = array();
	if ($vbulletin->options['tagcloud_usergroup'] > 0 AND !isset($vbulletin->usergroupcache[$vbulletin->options['tagcloud_usergroup']])){
		// handle a usergroup being deleted: default to live permission checking
		$vbulletin->options['tagcloud_usergroup'] = -1;
	}

	$cacheable = ($vbulletin->options['tagcloud_usergroup'] != -1);
	if (!$cacheable){
		$cloud = null;
	}
	else{
		switch ($vbulletin->options['vb4sidebar_tags_type']){
			case '2':
				$cloud = $vbulletin->searchcloud;
				break;
			case '1':
			default:
				$cloud = $vbulletin->tagcloud;
				break;
		}
	}

	if (!is_array($cloud) OR $cloud['dateline'] < (TIMENOW - (60 * $vbulletin->options['tagcloud_cachetime']))){
		if ($vbulletin->options['vb4sidebar_tags_type'] == 'search'){
			$tags_result = $vbulletin->db->query_read_slave("
				SELECT tagsearch.tagid, tag.tagtext, COUNT(*) AS searchcount
				FROM " . TABLE_PREFIX . "tagsearch AS tagsearch
				INNER JOIN " . TABLE_PREFIX . "tag AS tag ON (tagsearch.tagid = tag.tagid)
					" . ($vbulletin->options['tagcloud_searchhistory'] ?
				"WHERE tagsearch.dateline > " . (TIMENOW - (60 * 60 * 24 * $vbulletin->options['tagcloud_searchhistory'])) :
					'') . "
				GROUP BY tagsearch.tagid, tag.tagtext
				ORDER BY searchcount DESC
				LIMIT " . $vbulletin->options['tagcloud_tags']
			);
		}
		else{
			if (!$vbulletin->options['tagcloud_usergroup']){
				$perm_limit = false;
			}
			else{
				$forums = array();
				$perm_limit = true;

				foreach ($vbulletin->forumcache AS $forumid => $forum){
					// -1 for live permission checking
					$perm_array = ($vbulletin->options['tagcloud_usergroup'] == -1
						? $vbulletin->userinfo['forumpermissions']["$forumid"]
						: $forum['permissions'][$vbulletin->options['tagcloud_usergroup']]
					);
	
					if ($perm_array & $vbulletin->bf_ugp_forumpermissions['canview']
						AND $perm_array & $vbulletin->bf_ugp_forumpermissions['canviewthreads']
						AND $perm_array & $vbulletin->bf_ugp_forumpermissions['canviewothers']
					){
						$forums[] = intval($forumid);
					}
				}
			}

			if (!$perm_limit OR $forums){
				$tags_result = $vbulletin->db->query_read_slave("
					SELECT tagthread.tagid, tag.tagtext, COUNT(*) AS searchcount
					FROM " . TABLE_PREFIX . "tagthread AS tagthread
					INNER JOIN " . TABLE_PREFIX . "tag AS tag ON (tagthread.tagid = tag.tagid)
					INNER JOIN " . TABLE_PREFIX . "thread AS thread ON (tagthread.threadid = thread.threadid)
					WHERE thread.open <> 10
						AND thread.visible = 1
						" . ($perm_limit ? "AND thread.forumid IN (" . implode(',', $forums) . ")" : '') . "
						" . ($vbulletin->options['tagcloud_usagehistory'] ?
						"AND tagthread.dateline > " . (TIMENOW - (60 * 60 * 24 * $vbulletin->options['tagcloud_usagehistory'])) :
						'') . "
					GROUP BY tagthread.tagid, tag.tagtext
					ORDER BY searchcount DESC
					LIMIT " . $vbulletin->options['tagcloud_tags']
				);
			}
		}

		while ($currenttag = $vbulletin->db->fetch_array($tags_result)){
			$tags["$currenttag[tagtext]"] = $currenttag;
			$totals[$currenttag['tagid']] = $currenttag['searchcount'];
		}

		// fetch the stddev levels
		//$levels = fetch_standard_deviated_levels($totals, $vbulletin->options['tagcloud_levels']);

		if (!$count = sizeof($totals)){
			$levels = array();
		}
		else{
			$total = $summation = 0;
			$results = array();

			// calculate the total
			foreach ($totals AS $value){
				$total += $value;
			}

			// calculate the mean
			$mean = $total / $count;

			// calculate the summation
			foreach ($totals AS $id => $value){
				$summation += pow(($value - $mean), 2);
			}

			$sd = sqrt($summation / $count);

			if ($sd){
				$sdvalues = array();
				$lowestsds = 0;
				$highestsds = 0;

				// find the max and min standard deviations
				foreach ($totals AS $id => $value){
					$value = (($value - $mean) / $sd);
					$totals[$id] = $value;

					$lowestsds = min($value, $lowestsds);
					$highestsds = max($value, $highestsds);
				}

				foreach ($totals AS $id => $value){
					// normalize the std devs to 0 - 1, then map back to 1 - #levls
					$totals[$id] = round((($value - $lowestsds) / ($highestsds - $lowestsds)) * ($vbulletin->options['tagcloud_levels'] - 1)) + 1;
				}
			}
			else{
				foreach ($totals AS $id => $value){
					$totals[$id] = round($vbulletin->options['tagcloud_levels'] / 2);
				}
			}
	
			$levels = $totals;
		}
	
		// assign the levels back to the tags
		foreach ($tags AS $tagtext => $tag){
			$tags[$tagtext]['level'] = $levels[$tag['tagid']];
			$tags[$tagtext]['tagtext_url'] = urlencode(unhtmlspecialchars($tag['tagtext']));
		}

		// sort the categories by title
		uksort($tags, 'strnatcasecmp');

		$cloud = array(
			'tags' => $tags,
			'count' => sizeof($tags),
			'dateline' => TIMENOW
		);

		if ($cacheable){
			if ($vbulletin->options['vb4sidebar_tags_type'] == 'search'){
				$vbulletin->searchcloud = $cloud;
				build_datastore('searchcloud', serialize($cloud), 1);
			}
			else{
				$vbulletin->tagcloud = $cloud;
				build_datastore('tagcloud', serialize($cloud), 1);
			}
		}
	}

	if (empty($cloud['tags'])){
		$cumulustagcloud = '';
	}
	else{
		$i = -1;
		foreach ($cloud['tags'] AS $thistag){
			$i++;
			$cumulustagcloud[$i][tagtext_url] = $thistag[tagtext_url];
			$cumulustagcloud[$i][level] = $thistag[level];
			$cumulustagcloud[$i][tagtext] = $thistag[tagtext];
		}
		$nbtags = $i;
	}

	if (!(empty($cumulustagcloud))){
		$iMax = $nbtags;
		if ($nbtags > $vbulletin->options['vb4sidebar_maxtags']){
			$iMax = $vbulletin->options['vb4sidebar_maxtags'];
		}

		$vbcumuluswidget_tagcloud = '%3Ctags%3E';

		for ($i = 0; $i < $iMax; $i++) {
			$j = rand(2,$nbtags);
			$cumulustag_tagtext = $cumulustagcloud[$j][tagtext];
			$cumulustag_level = intval($cumulustagcloud[$j][level]);
			$cumulustag_link = 'tags.php?'.$vbulletin->session->vars[sessionurl].'tag='.$cumulustagcloud[$j][tagtext_url];

			switch ($cumulustag_level){
				case "1": $fontsize = '9'; break;
				case "2": $fontsize = '12'; break;
				case "3": $fontsize = '15'; break;
				case "4": $fontsize = '18'; break;
				case "5": $fontsize = '21'; break;
			}
			$taglink = urlencode($cumulustag_link);
			$tagtext = urlencode($cumulustag_tagtext);
			if (!(empty($fontsize))){
				$vbcumuluswidget_tagcloud .= '%3Ca+href%3D%27'.$taglink.'%27+rel%3D%22tag%22+style%3D%27font-size%3A+'.$fontsize.'pt%3B%27%3E'.$tagtext.'%3C%2Fa%3E%0A';
			}
		}
		$vbcumuluswidget_tagcloud .= '%3C%2Ftags%3E';
	}
	else{
		$tagtext = urlencode($vbphrase['vb4sidebar_no_tag_found']);
		$vbcumuluswidget_tagcloud = '%3Ctags%3E';
	
		for($i = 0; $i < $vbulletin->options['vb4sidebar_maxtags']; $i++) {
			// Create randomizer
			// Use switch statement to find font size
			$randomizer = rand(1,5);
			switch ($randomizer){
				case "1": $fontsize = '9'; break;
				case "2": $fontsize = '12'; break;
				case "3": $fontsize = '15'; break;
				case "4": $fontsize = '18'; break;
				case "5": $fontsize = '21'; break;
			}
			$vbcumuluswidget_tagcloud .= '%3Ca+href%3D%27%23%27+rel%3D%22tag%22+style%3D%27font-size%3A+'.$fontsize.'pt%3B%27%3E'.$tagtext.'%3C%2Fa%3E%0A';
		}
		$vbcumuluswidget_tagcloud .= '%3C%2Ftags%3E';
	}

	// add random seeds to so name and movie url to avoid collisions and force reloading (needed for IE)
	$vbcumuluswidget_soname = 'widget_so_' . rand(0,9999999);
	$vbcumuluswidget_movie = $vbulletin->options[bburl].'/clientscript/vb_cumulus/tagcloud.swf?r=' . rand(0,9999999);
	$vbcumuluswidget_div_id = 'vbcumuluswidgetcontent' . rand(0,9999999);

	$outputarray = array();
	$outputarray['soname'] = $vbcumuluswidget_soname;
	$outputarray['div_id'] = $vbcumuluswidget_div_id;
	$outputarray['movie'] = $vbcumuluswidget_movie;
	$outputarray['tagcloud'] = $vbcumuluswidget_tagcloud; 

	return $outputarray;
}

?>